/*
 *  Authors: Jackie Liu <liuyun01@kylinos.cn>
 *
 *  Copyright (C) 2018,Tianjin KYLIN Information Technology Co., Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#ifndef _MACHINE_TYPE_H_
#define _MACHINE_TYPE_H_

#include <linux/types.h>
#include <linux/acpi.h>
#include <asm/phytium_platform.h>

enum {
	ACPI_FT2500 		= 1,
	ACPI_FT2000A_4		= 2,
	/* TODO: tag other cpus */
};

int acpi_init_cpu_type(void);
bool get_cpu_type(u32 cpu_type);

#define is_ft1500a()	is_part(MIDR_FT_1500A)
#define is_ft2000ahk()	is_part(MIDR_FT_2000AHK)
#define is_ft2000plus()	is_part(MIDR_FT_2000PLUS)
#define is_ft2500()	get_cpu_type(ACPI_FT2500)
#define is_ft2000a4()	get_cpu_type(ACPI_FT2000A_4)
#define is_ft_all()	is_implementer(ARM_CPU_IMP_PHYTIUM)

#define is_kunpeng920()	is_part(MIDR_HISI_TSV110)
#define is_hisi()	is_implementer(ARM_CPU_IMP_HISI)

#endif
