#ifndef __KSEMEM_COMMON_H__
#define __KSEMEM_COMMON_H__	1

//#include "semem_config.h"


#define SEMEM_MODULE_VERSION	"2.0.6"

/* ksemem_common.h can be included by all modules, eg, rcd and platform */
/* this file only defines basic interfaces and macros for all */

#ifndef TRUE
#define TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

#define __BIT	((unsigned int)1)

#ifndef BIT0
#define BIT0  __BIT
#define BIT1  (__BIT << 1)
#define BIT2  (__BIT << 2)
#define BIT3  (__BIT << 3)
#define BIT4  (__BIT << 4)
#define BIT5  (__BIT << 5)
#define BIT6  (__BIT << 6)
#define BIT7  (__BIT << 7)
#define BIT8  (__BIT << 8)
#define BIT9  (__BIT << 9)
#endif
#ifndef BIT10
#define BIT10 (__BIT << 10)
#define BIT11 (__BIT << 11)
#define BIT12 (__BIT << 12)
#define BIT13 (__BIT << 13)
#define BIT14 (__BIT << 14)
#define BIT15 (__BIT << 15)
#define BIT16 (__BIT << 16)
#define BIT17 (__BIT << 17)
#define BIT18 (__BIT << 18)
#define BIT19 (__BIT << 19)
#define BIT20 (__BIT << 20)
#define BIT21 (__BIT << 21)
#define BIT22 (__BIT << 22)
#define BIT23 (__BIT << 23)
#define BIT24 (__BIT << 24)
#define BIT25 (__BIT << 25)
#define BIT26 (__BIT << 26)
#define BIT27 (__BIT << 27)
#define BIT28 (__BIT << 28)
#define BIT29 (__BIT << 29)
#define BIT30 (__BIT << 30)
#define BIT31 (__BIT << 31)
#endif

#define INTEGER_CMP(a, b, type) \
	({\
		int ____ret = 0;\
		if ((type)(a) == (type)(b)){\
			____ret = 0;\
		}else if ((type)(a) > (type)(b)){\
			____ret = 1;\
		}else{\
			____ret = -1;\
		}\
		____ret;\
	})

#define ULONG_CMP(a, b)	INTEGER_CMP(a, b, unsigned long)
#define UINT_CMP(a, b) INTEGER_CMP(a, b, unsigned int)

#define KB	(1024ul)
#define MB	(1024ul * KB)
#define GB	(1024ul * MB)

static inline unsigned long get_bits(unsigned long data, int start, int bits_nr){
	unsigned long mask = (1ul << bits_nr) - 1;
	data >>= start;

	return data & mask;
}


#if defined(CONFIG_DEBUG)
  #define SCDIMM_DEBUG_INFO(...) printk(KERN_INFO __VA_ARGS__)
  #define SCDIMM_DEBUG_ERROR(...) printk(KERN_ERR __VA_ARGS__)
  #define SCDIMM_DEBUG_DEBUG(...) printk(KERN_ERR __VA_ARGS__)
#else
  #define SCDIMM_DEBUG_INFO(...)
  #define SCDIMM_DEBUG_ERROR(...)
  #define SCDIMM_DEBUG_DEBUG(...)
#endif

#define SCDIMM_INFO(...) printk(KERN_INFO __VA_ARGS__)
#define SCDIMM_CRIT(...) printk(KERN_CRIT __VA_ARGS__)


static inline unsigned long l_shift_u64(unsigned long op, int count){
  return op << count;
}


static inline unsigned long r_shift_u64 (unsigned long op, int count){
	return op >> count;
}

static inline unsigned long bit_field_read64(unsigned long op, int start, int end){
	return r_shift_u64 (op & ~ l_shift_u64((unsigned long)-2, end), start);
}

struct _buf_head{
    unsigned long size;
    unsigned long unit, align_unit;
    long total, index;
    void *buf;
};

typedef struct _buf_head buf_head;

extern buf_head *buf_alloc(unsigned long object_size, unsigned long align_size);
extern int buf_destroy(buf_head **head);
extern int buf_head_free(buf_head **head);
extern int buf_double(buf_head *head);
extern void *buf_current_object(buf_head *head);
extern int buf_enqueue(buf_head *head, void *object_ptr);
extern int buf_iterate(buf_head *head, unsigned int index, void *object_ptr);
extern int buf_ref(buf_head *head, unsigned int index, void **object_ptr);
extern long buf_object_nr(buf_head *head);
extern void buf_reset(buf_head *head);


#endif


